//+------------------------------------------------------------------+
//|                                               ADX_with_Alert.mq4 |
//|                                   Copyright  2008, Serega Lykov |
//|                                       http://mtexperts.narod.ru/ |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, Serega Lykov"
#property link      "http://mtexperts.narod.ru/"

//----   ------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LightSeaGreen
#property indicator_color2 YellowGreen
#property indicator_color3 Wheat

//----   --------------------------------------------+
extern string _____ADX______________;
extern int    ADX_Period          = 14;       //   ADX
extern int    ADX_AppPrice        = 0;        //   ADX:      0 = PRICE_CLOSE, 1 = PRICE_OPEN,
                                              // 2 = PRICE_HIGH,    3 = PRICE_LOW,   4 = 0PRICE_MEDIAN,
                                              // 5 = PRICE_TYPICAL, 6 = PRICE_WEIGHTED
extern bool   SignalOnlyAfterCloseBar = false; // true =       
extern bool   UseSmooth_ADX       = false;    // true =   ADX
extern int    ADX_MASmooth_Period = 7;        //   MA ( ADX)
extern int    ADX_MASmooth_Method = 0;        //   MA ( ADX): 0-Simple, 1-Exponential, 2-Smoothed, 3-Weighted
extern bool   UseSmooth_DI        = false;    // true =   DI
extern int    DI_MASmooth_Period  = 7;        //   MA ( DI)
extern int    DI_MASmooth_Method  = 0;        //   MA ( DI): 0-Simple, 1-Exponential, 2-Smoothed, 3-Weighted
extern string _____Signal_ADX_______;
extern bool   UseSignal_ADX       = true;     // /  Alert'     ADX
extern int    Level               = 20;       //  ADX,     
extern color  LevelColor          = RoyalBlue; //    
extern bool   ADX_EmailAlert      = true;     // true =   e-mail
extern bool   ADX_PopUpAlert      = true;     // true =    
extern bool   ADX_SoundAlert      = true;     // true =     
extern string ADX_SoundFile_Buy   = "alert.wav";  //   ,       
extern string ADX_SoundFile_Sell  = "alert2.wav"; //   ,        
extern bool   ADX_DrawVertLine    = true;     // true =  ,     
extern color  ADX_VLineColor_Buy  = Blue;     //       
extern color  ADX_VLineColor_Sell = Red;      //       
extern string _____Signal_DI________;
extern bool   UseSignal_DI        = true;     // /  Alert'     DI
extern bool   DI_EmailAlert       = true;     // true =   e-mail
extern bool   DI_PopUpAlert       = true;     // true =    
extern bool   DI_SoundAlert       = true;     // true =     
extern string DI_SoundFile_Buy    = "alert.wav";  //   ,        
extern string DI_SoundFile_Sell   = "alert2.wav"; //   ,        
extern bool   DI_DrawVertLine     = true;     // true =  ,     
extern color  DI_VLineColor_Buy   = Blue;     //       
extern color  DI_VLineColor_Sell  = Red;      //       

//----  ------------------------------------------------------+
static double ADXBuffer[];
static double pDIBuffer[];
static double mDIBuffer[];
static double ADXBufferSmooth[];
static double pDIBufferSmooth[];
static double mDIBufferSmooth[];

//----   ----------------------------------------+
static datetime prevtime_adx;
static datetime prevtime_di;
static string   name_level  = "adx_hline";
static string   adx_message = " ADX    .";
static string   pdi_message = " +DI   -DI  .";
static string   mdi_message = " -DI   +DI  .";
static string   short_name;
static int      shift;

//----   -------------------------------------+
int init()
  {
//---- 3  
   IndicatorBuffers(6);
//----  ""  
   if(!UseSmooth_ADX && !UseSmooth_DI) string smooth = "";
   else
     {
      if(!UseSmooth_ADX) string smt_adx = "";
      else
        {
         switch(ADX_MASmooth_Method)
           {
            case 1: { smt_adx = "EMA(";  break; }
            case 2: { smt_adx = "SMMA("; break; }
            case 3: { smt_adx = "LWMA("; break; }
            default:  smt_adx = "SMA(";
           }
         smt_adx = StringConcatenate(smt_adx,ADX_MASmooth_Period,")");
        }
      if(!UseSmooth_DI) string smt_di = "";
      else
        {
         switch(DI_MASmooth_Method)
           {
            case 1: { smt_di = "EMA(";  break; }
            case 2: { smt_di = "SMMA("; break; }
            case 3: { smt_di = "LWMA("; break; }
            default:  smt_di = "SMA(";
           }
         smt_di = StringConcatenate(smt_di,DI_MASmooth_Period,")");
        }
      smooth = StringConcatenate(" with Smooth [",smt_adx,",",smt_di,"]");
     }
   short_name = StringConcatenate("ADX_with_Alert(",ADX_Period,")",smooth);
   IndicatorShortName(short_name);
//----    
   IndicatorDigits(4);
//----    
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
   SetIndexStyle(2,DRAW_LINE,STYLE_DOT);
//----     
   SetIndexBuffer(0,ADXBuffer);
   SetIndexBuffer(1,pDIBuffer);
   SetIndexBuffer(2,mDIBuffer);
   SetIndexBuffer(3,ADXBufferSmooth);
   SetIndexBuffer(4,pDIBufferSmooth);
   SetIndexBuffer(5,mDIBufferSmooth);
//----      
   SetIndexDrawBegin(0,ADX_Period);
   SetIndexDrawBegin(1,ADX_Period);
   SetIndexDrawBegin(2,ADX_Period);
//----    
   SetIndexLabel(0,"ADX");
   SetIndexLabel(1,"+DI");
   SetIndexLabel(2,"-DI");
//----  
   if(SignalOnlyAfterCloseBar) shift = 1;
   else shift = 0;
//----   
   prevtime_adx = Time[0];
   prevtime_di = Time[0];
//----  
   return(0);
  }

//----   -----------------------------------+
int deinit()
  {
//----   
   int obj_total = ObjectsTotal() - 1;
   for(int i=obj_total; i>=0; i--)
     {
      string name = ObjectName(i);
      if(ObjectType(name) != OBJ_VLINE) continue;
      if(StringFind(name,"adx_vline",0) < 0) continue;
      ObjectDelete(name);
     }
   return(0);
  }

//---- ADX with Alert -----------------------------------------------+
int start()
  {
   //  
   if(ObjectFind(name_level) < 0)
     {
      ObjectCreate(name_level,OBJ_HLINE,WindowFind(short_name),0,Level);
      ObjectSet(name_level,OBJPROP_STYLE,STYLE_DASHDOTDOT);
      ObjectSet(name_level,OBJPROP_COLOR,LevelColor);
     }
   double obj_level = NormalizeDouble(ObjectGet(name_level,OBJPROP_PRICE1),4);
   if(Level != obj_level)
     {
      Level = MathRound(obj_level);
      ObjectMove(name_level,0,Time[0],Level);
     }
   //     ,    
   if(Bars <= ADX_Period) return(0);
   //       
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   //     
   if(counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   //   ADX
   if(!UseSmooth_ADX)
     {
      for(int i=0; i<limit; i++)
        {
         ADXBuffer[i] = iADX(NULL,0,ADX_Period,ADX_AppPrice,MODE_MAIN,i);
         ADXBufferSmooth[i] = EMPTY_VALUE;
        }
     }
   else
     {
      for(i=0; i<limit; i++) ADXBufferSmooth[i] = iADX(NULL,0,ADX_Period,ADX_AppPrice,MODE_MAIN,i);
      for(i=0; i<limit; i++) ADXBuffer[i] = iMAOnArray(ADXBufferSmooth,0,ADX_MASmooth_Period,0,ADX_MASmooth_Method,i);
     }
   if(!UseSmooth_DI)
     {
      for(i=0; i<limit; i++)
        {
         pDIBuffer[i] = iADX(NULL,0,ADX_Period,ADX_AppPrice,MODE_PLUSDI,i);
         mDIBuffer[i] = iADX(NULL,0,ADX_Period,ADX_AppPrice,MODE_MINUSDI,i);
         pDIBufferSmooth[i] = EMPTY_VALUE;
         mDIBufferSmooth[i] = EMPTY_VALUE;
        }
     }
   else
     {
      for(i=0; i<limit; i++)
        {
         pDIBufferSmooth[i] = iADX(NULL,0,ADX_Period,ADX_AppPrice,MODE_PLUSDI,i);
         mDIBufferSmooth[i] = iADX(NULL,0,ADX_Period,ADX_AppPrice,MODE_MINUSDI,i);
        }
      for(i=0; i<limit; i++)
        {
         pDIBuffer[i] = iMAOnArray(pDIBufferSmooth,0,DI_MASmooth_Period,0,DI_MASmooth_Method,i);
         mDIBuffer[i] = iMAOnArray(mDIBufferSmooth,0,DI_MASmooth_Period,0,DI_MASmooth_Method,i);
        }
     }
   // ,   ADX     
   if(UseSignal_ADX)
     {
      if(prevtime_adx != Time[0])
        {
         if(ADXBuffer[shift+1] <= Level && ADXBuffer[shift] > Level)
           {
            if(pDIBuffer[shift] > mDIBuffer[shift])
              {
               if(ADX_SoundAlert) PlaySound(ADX_SoundFile_Buy);
               if(ADX_EmailAlert) SendMail(StringConcatenate("   \"",short_name,"\""),StringConcatenate("BUY-  ",Symbol(),"  ",TimeToStr(TimeCurrent()),adx_message));
               if(ADX_PopUpAlert) Alert(StringConcatenate(" \"",short_name,"\":\nBUY-  ",Symbol(),"  ",TimeToStr(TimeCurrent()),"\n",adx_message));
               if(ADX_DrawVertLine)
                 {
                  string name = StringConcatenate("adx_vline BUY ",Symbol()," ",TimeToStr(Time[0]));
                  ObjectCreate(name,OBJ_VLINE,0,Time[0],0);
                  ObjectSet(name,OBJPROP_COLOR,ADX_VLineColor_Buy); 
                 }
              }
            else
              {
               if(ADX_SoundAlert) PlaySound(ADX_SoundFile_Sell);
               if(ADX_EmailAlert) SendMail(StringConcatenate("   \"",short_name,"\""),StringConcatenate("SELL-  ",Symbol(),"  ",TimeToStr(TimeCurrent()),adx_message));
               if(ADX_PopUpAlert) Alert(StringConcatenate(" \"",short_name,"\":\nSELL-  ",Symbol(),"  ",TimeToStr(TimeCurrent()),"\n",adx_message));
               if(ADX_DrawVertLine)
                 {
                  name = StringConcatenate("adx_vline SELL ",Symbol()," ",TimeToStr(Time[0]));
                  ObjectCreate(name,OBJ_VLINE,0,Time[0],0);
                  ObjectSet(name,OBJPROP_COLOR,ADX_VLineColor_Sell);
                 }
              }
            prevtime_adx = Time[0];
           }
        }
     }
   // ,   +DI  -DI 
   if(UseSignal_DI)
     {
      if(prevtime_di != Time[0])
        {
         if(pDIBuffer[shift+1] <= mDIBuffer[shift+1] && pDIBuffer[shift] > mDIBuffer[shift])
           {
            if(DI_SoundAlert) PlaySound(DI_SoundFile_Buy);
            if(DI_EmailAlert) SendMail(StringConcatenate("   \"",short_name,"\""),StringConcatenate("BUY-  ",Symbol(),"  ",TimeToStr(TimeCurrent()),pdi_message));
            if(DI_PopUpAlert) Alert(StringConcatenate(" \"",short_name,"\":\nBUY-  ",Symbol(),"  ",TimeToStr(TimeCurrent()),"\n",pdi_message));
            if(DI_DrawVertLine)
              {
               name = StringConcatenate("adx_vline BUY ",Symbol()," ",TimeToStr(Time[0]));
               ObjectCreate(name,OBJ_VLINE,0,Time[0],0);
               ObjectSet(name,OBJPROP_COLOR,DI_VLineColor_Buy); 
              }
            prevtime_di = Time[0];
           }
         if(pDIBuffer[shift+1] >= mDIBuffer[shift+1] && pDIBuffer[shift] < mDIBuffer[shift])
           {
            if(DI_SoundAlert) PlaySound(DI_SoundFile_Sell);
            if(DI_EmailAlert) SendMail(StringConcatenate("   \"",short_name,"\""),StringConcatenate("SELL-  ",Symbol(),"  ",TimeToStr(TimeCurrent()),mdi_message));
            if(DI_PopUpAlert) Alert(StringConcatenate(" \"",short_name,"\":\nSELL-  ",Symbol(),"  ",TimeToStr(TimeCurrent()),"\n",mdi_message));
            if(DI_DrawVertLine)
              {
               name = StringConcatenate("adx_vline SELL ",Symbol()," ",TimeToStr(Time[0]));
               ObjectCreate(name,OBJ_VLINE,0,Time[0],0);
               ObjectSet(name,OBJPROP_COLOR,DI_VLineColor_Sell); 
              }
            prevtime_di = Time[0];
           }
        }
     }
   //  
   return(0);
  }
  
//+------------------------------------------------------------------+